---
title: visibility
slug: Web/SVG/Attribute/visibility
tags:
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <strong><code>visibility</code></strong> attribute lets you control the visibility of graphical elements. With a value of <code>hidden</code> or <code>collapse</code> the current graphics element is invisible.</p>

<div class="note"><strong>Note:</strong> If the <code>visibility</code> attribute is set to <code>hidden</code> on a text element, then the text is invisible but still takes up space in text layout calculations.</div>

<p>Depending on the value of attribute {{SVGAttr("pointer-events")}}, graphics elements which have their <code>visibility</code> attribute set to <code>hidden</code> still might receive events.</p>

<p class="note"><strong>Note:</strong> As a presentation attribute, <code>visibility</code> can be used as a CSS property. See the {{cssxref("visibility", "CSS visibility")}} property for more information.</p>

<p>As a presentation attribute, it can be applied to any element but it has effect only on the following nineteen elements: {{SVGElement("a")}}, {{SVGElement("altGlyph")}}, {{SVGElement("audio")}}, {{SVGElement("canvas")}}, {{SVGElement("circle")}}, {{SVGElement("ellipse")}}, {{SVGElement("foreignObject")}}, {{SVGElement("iframe")}}, {{SVGElement("image")}}, {{SVGElement("line")}}, {{SVGElement("path")}}, {{SVGElement("polygon")}}, {{SVGElement("polyline")}}, {{SVGElement("rect")}}, {{SVGElement("text")}}, {{SVGElement("textPath")}}, {{SVGElement("tref")}}, {{SVGElement("tspan")}}, {{SVGElement("video")}}</p>

<div id="topExample">
<div class="hidden">
<pre class="brush: css">html, body, svg {
  height: 100%;
}</pre>
</div>

<pre class="brush: html; hightlight[5,6]">&lt;svg viewBox="0 0 220 120" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;rect x="10" y="10" width="200" height="100" stroke="black"
      stroke-width="5" fill="transparent" /&gt;
  &lt;g stroke="seagreen" stroke-width="5" fill="skyblue"&gt;
    &lt;rect x="20" y="20" width="80" height="80" visibility="visible" /&gt;
    &lt;rect x="120" y="20" width="80" height="80" visibility="hidden"/&gt;
  &lt;/g&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample("topExample", "250", "100")}}</p>
</div>

<h2 id="Usage_notes">Usage notes</h2>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>visible</code> | <code>hidden</code> | <code>collapse</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>visible</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>Yes</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt><code>visible</code></dt>
 <dd>This value indicates that the element will be painted.</dd>
 <dt><code>hidden</code></dt>
 <dd>This value indicates that the element will not be painted. Though it is still part of the rendering tree, i.e. it may receive pointer events depending on the {{SVGAttr("pointer-events")}} attribute, may receive focus depending on the {{SVGAttr("tabindex")}} attribute, contributes to bounding box calculations and clipping paths, and does affect text layout.</dd>
 <dt><code>collapse</code></dt>
 <dd>This value is equal to <code>hidden</code>.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following example toggles the CSS <code>visibility</code> of the SVG image path.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;button id="nav-toggle-button" &gt;
  &lt;svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" class="button-icon"&gt;
    &lt;path d="M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z" /&gt;
    &lt;path d="M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z" class="invisible" /&gt;
    &lt;path d="M0 0h24v24H0z" fill="none" /&gt;
  &lt;/svg&gt;
  &lt;span&gt;
    click me
  &lt;/span&gt;
&lt;/button&gt;  </pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css">svg {
  display: inline !important;
}
span {
  vertical-align: 50%;
}
button {
  line-height: 1em;
}
.invisible {
  visibility: hidden;
}</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">document.querySelector("button").addEventListener("click", function (evt) {
  this.querySelector("svg &gt; path:nth-of-type(1)").classList.toggle("invisible");
  this.querySelector("svg &gt; path:nth-of-type(2)").classList.toggle("invisible");
}); </pre>

<p>{{EmbedLiveSample("Example", "100%", "80")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS2.1", "visufx.html#visibility", "visibility")}}</td>
   <td>{{Spec2("CSS2.1")}}</td>
   <td>CSS definition of the property</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG2", "render.html#VisibilityControl", "visibility")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>Mainly refers to CSS 2.1</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "painting.html#VisibilityProperty", "visibility")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("svg.attributes.presentation.visibility")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{SVGAttr("display")}} attribute</li>
 <li>{{cssxref("visibility", "CSS visibility")}}</li>
</ul>
